if arg[1] == nil then
	io.write("pbdllwrapper.lua:\n")
	io.write("	A script to generate purebasic dll wrapper functions.\n")
	io.write("	Author: Florian 'FloHimself' Schaefer, 2004-06-16\n\n")
	io.write("	Usage: lua pbdlltool.lua declarefile.pb [>wrapperfunctions.pb]\n")
	os.exit()
elseif io.open(arg[1], "r") == nil then
	io.write("pbdllwrapper.lua:\n")
	io.write("	bad argument #1 to 'open file' (filename expected)")
	os.exit()
end

local dllname
if string.upper(string.sub(arg[1], -2, -1)) == "PB" then
	dllname = string.sub(arg[1], 1, -4)
else
	dllname = arg[1]
end

io.write("#DLL_"..dllname.." = 0\n\n")
io.write("Procedure.b Open_"..dllname.."_DLL()\n")
io.write("  If OpenLibrary(#DLL_"..dllname..", \""..dllname..".dll\")\n")  
io.write("    ProcedureReturn #True\n")
io.write("  Else\n")
io.write("    ProcedureReturn #False\n")
io.write("  EndIf\n")
io.write("EndProcedure\n\n")

io.write("Procedure Close_"..dllname.."_DLL()\n")
io.write("  CloseLibrary(#DLL_"..dllname..")\n")  
io.write("EndProcedure\n\n")

f = assert(io.open(arg[1], "r"))
while true do
	local line = f:read("*line")
	if line == nil then break end
	string.gsub(line, "%s*[Dd]eclare(C?)DLL(\.[bwlfs])%s+([%w_]+)%s*[(](.*)[)].*", function(w,x,y,z)
		--[[
		w -> Functiontype [DLL | CDLL]
		x -> Functiontype [bwlfs]
		y -> Functionname
		z -> Functionparameters
		]]
		 
		local pCount = 0
		local _, NrFuncParams = string.gsub(z, "," , "")
		NrFuncParams=NrFuncParams+1
		
		local cdll = 0
		
		if w == "" then
			cdll = 0
		else
			cdll = 1
		end
		
		io.write("Procedure"..x.." "..y.."(")
		if pCount == 0 then
			string.gsub(z, "([%w]+.%w),*", function(x)
				pCount=pCount+1
				if pCount == NrFuncParams then
					io.write("arg"..tostring(pCount).."."..string.sub(x, -1, -1))				
				else
					io.write("arg"..tostring(pCount).."."..string.sub(x, -1, -1)..", ")
				end
				
				 
				end
			)
		end
		io.write(")\n")
		
		if cdll == 1 then
			io.write("  ProcedureReturn CallCFunction(#DLL_"..dllname..", \""..y.."\"")
		else
			io.write("  ProcedureReturn CallFunction(#DLL_"..dllname..", \""..y.."\"")
		end
		
		if pCount > 0 then 
			io.write(",")
			for i=1, pCount do
				io.write(" arg"..tostring(i))
				if i ~= NrFuncParams then
					io.write(",")				
				end
			end
		end
				
		io.write(")\n")
		io.write("EndProcedure\n\n")

		end					
	)
end