/*
**
** LUA 5.0.2 Wrapper PureBasic Library (27/05/2004)
** (C) 2004 by Florian 'FloHimself' Schfer - FloHimself@web.de
** 
** This LUA 5.0.2 Wrapper PureBasic Library is free. 
**
** Warranty
**
** The Lua PureBasic Library and any support from FloHimself are  provided 
** "as is" and without warranty, express and implied,  including  but  not 
** limited to any implied warranties of merchantability  and fitness for a 
** particular  purpose. In  no  event  will  FloHimself  be liable for any 
** damages, including lost  profits, lost savings, or  other incidental or 
** consequential damages, even if FloHimself is advised of the possibility 
** of such damages, or for any claim by you or any third party.
**
** Acknowledgments
**
** Lua 5.0.2 is Copyright (C) 2003-2004 Tecgraf, PUC-Rio 
** (see http://www.lua.org)
**
** PureBasic is Copyright (C) 2003 by Fantaisie Software
** (see http://www.purebasic.com)
** 
*/

#include <Windows.h>
#include "lua.h"
#include "lualib.h"
#include "lauxlib.h"
#include "pblua.h"

/* LUA.H */

/*
** state manipulation 
*/

PBCOMMAND(lua_State*) PB_lua_open(void)
{
  return lua_open();
}

PBCOMMAND(void) PB_lua_close(lua_State *L)
{
  lua_close(L);
}

PBCOMMAND(lua_State*) PB_lua_newthread(lua_State *L)
{
  return lua_newthread(L);
}

PBCOMMAND(lua_CFunction) PB_lua_atpanic(lua_State *L, lua_CFunction panicf)
{
  return lua_atpanic(L, panicf);
}

/*
** basic stack manipulation
*/
PBCOMMAND(int) PB_lua_gettop(lua_State *L)
{
  return lua_gettop(L);
}

PBCOMMAND(void) PB_lua_settop(lua_State *L, int idx)
{
  lua_settop(L, idx);
}

PBCOMMAND(void) PB_lua_pushvalue(lua_State *L, int idx)
{
  lua_pushvalue(L, idx);
}

PBCOMMAND(void) PB_lua_remove(lua_State *L, int idx)
{
  lua_remove(L, idx);
}

PBCOMMAND(void) PB_lua_insert(lua_State *L, int idx)
{
  lua_insert(L, idx);
}

PBCOMMAND(void) PB_lua_replace(lua_State *L, int idx)
{
  lua_replace(L, idx);
}

PBCOMMAND(int) PB_lua_checkstack(lua_State *L, int sz)
{
  return lua_checkstack(L, sz);
}

PBCOMMAND(void) PB_lua_xmove(lua_State *from, lua_State *to, int n)
{
  lua_xmove (from, to, n);
}

/*
** access functions (stack -> C)
*/

PBCOMMAND(int) PB_lua_isnumber(lua_State *L, int idx)
{
  return lua_isnumber(L, idx);
}

PBCOMMAND(int) PB_lua_isstring(lua_State *L, int idx)
{
  return lua_isstring(L, idx);
}

PBCOMMAND(int) PB_lua_iscfunction(lua_State *L, int idx)
{
  return lua_iscfunction(L, idx);
}

PBCOMMAND(int) PB_lua_isuserdata(lua_State *L, int idx)
{
  return lua_isuserdata (L, idx);
}

PBCOMMAND(int) PB_lua_type(lua_State *L, int idx)
{
  return lua_type(L, idx);
}

PBCOMMAND(const char*) PB_lua_typename(lua_State *L, int tp)
{
  return lua_typename(L, tp);
}

PBCOMMAND(int) PB_lua_equal(lua_State *L, int idx1, int idx2)
{
  return lua_equal(L, idx1, idx2);
}

PBCOMMAND(int) PB_lua_rawequal(lua_State *L, int idx1, int idx2)
{
  return lua_rawequal(L, idx1, idx2);
}

PBCOMMAND(int) PB_lua_lessthan(lua_State *L, int idx1, int idx2)
{
  return lua_lessthan(L, idx1, idx2);
}

PBCOMMAND(float) PB_lua_tonumber(lua_State *L, int idx)
{
  return (float) lua_tonumber(L, idx);
}

PBCOMMAND(int) PB_lua_toboolean(lua_State *L, int idx)
{
  return lua_toboolean(L, idx);
}

PBCOMMAND(const char*) PB_lua_tostring(lua_State *L, int idx)
{
  return lua_tostring(L, idx);
}

PBCOMMAND(size_t) PB_lua_strlen(lua_State *L, int idx)
{
  return lua_strlen(L, idx);
}

PBCOMMAND(lua_CFunction) PB_lua_tocfunction(lua_State *L, int idx)
{
  return lua_tocfunction(L, idx);
}

PBCOMMAND(void*) PB_lua_touserdata(lua_State *L, int idx)
{
  return lua_touserdata(L, idx);
}

PBCOMMAND(lua_State*) PB_lua_tothread(lua_State *L, int idx)
{
  return lua_tothread(L, idx);
}

PBCOMMAND(const void*) PB_lua_topointer(lua_State *L, int idx)
{
  return lua_topointer(L, idx);
}

/*
** push functions (C -> stack)
*/

PBCOMMAND(void) PB_lua_pushnil(lua_State *L)
{
  lua_pushnil(L);
}

PBCOMMAND(void) PB_lua_pushnumber(lua_State *L, float n)
{
  lua_pushnumber(L, (lua_Number) n);
}

PBCOMMAND(void) PB_lua_pushlstring(lua_State *L, const char *s, size_t l)
{
  lua_pushlstring(L, s, l);
}

PBCOMMAND(void) PB_lua_pushstring(lua_State *L, const char *s)
{
  lua_pushstring(L, s);
}


PBCOMMAND(const char*) PB_lua_pushvfstring(lua_State *L, const char *fmt,
                                          va_list argp)
{
  return lua_pushvfstring(L, fmt, argp);
}

/*
LUA_API const char *lua_pushfstring (lua_State *L, const char *fmt, ...);
*/                                                  

PBCOMMAND(void) PB_lua_pushcclosure(lua_State *L, lua_CFunction fn, int n)
{
  lua_pushcclosure(L, fn, n);
}

PBCOMMAND(void) PB_lua_pushboolean(lua_State *L, int b)
{
  lua_pushboolean(L, b);
}

PBCOMMAND(void) PB_lua_pushlightuserdata(lua_State *L, void *p)
{
  lua_pushlightuserdata(L, p);  
}

/*
** get functions (Lua -> stack)
*/
PBCOMMAND(void) PB_lua_gettable(lua_State *L, int idx)
{
  lua_gettable(L, idx);
}

PBCOMMAND(void) PB_lua_rawget(lua_State *L, int idx)
{
  lua_rawget(L, idx);
}

PBCOMMAND(void) PB_lua_rawgeti(lua_State *L, int idx, int n)
{
  lua_rawgeti(L, idx, n);
}

PBCOMMAND(void) PB_lua_newtable(lua_State *L)
{
  lua_newtable(L);
}

PBCOMMAND(void*) PB_lua_newuserdata(lua_State *L, size_t sz)
{
  return lua_newuserdata(L, sz);
}

PBCOMMAND(int) PB_lua_getmetatable(lua_State *L, int objindex)
{
  return lua_getmetatable(L, objindex);
}

PBCOMMAND(void) PB_lua_getfenv(lua_State *L, int idx)
{
  lua_getfenv(L, idx);
}

/*
** set functions (stack -> Lua)
*/

PBCOMMAND(void) PB_lua_settable(lua_State *L, int idx)
{
  lua_settable(L, idx);
}

PBCOMMAND(void) PB_lua_rawset(lua_State *L, int idx)
{
  lua_rawset(L, idx);
}

PBCOMMAND(void) PB_lua_rawseti(lua_State *L, int idx, int n)
{
  lua_rawseti(L, idx, n);
}

PBCOMMAND(int) PB_lua_setmetatable(lua_State *L, int objindex)
{
  return lua_setmetatable(L, objindex);
}

PBCOMMAND(int) PB_lua_setfenv(lua_State *L, int idx)
{
  return lua_setfenv(L, idx);
}

/*
** `load' and `call' functions (load and run Lua code)
*/

PBCOMMAND(void)PB_lua_call(lua_State *L, int nargs, int nresults)
{
  lua_call(L, nargs, nresults);
}

PBCOMMAND(int) PB_lua_pcall(lua_State *L, int nargs, int nresults, int errfunc)
{
  return lua_pcall(L, nargs, nresults, errfunc);
}

PBCOMMAND(int) PB_lua_cpcall(lua_State *L, lua_CFunction func, void *ud)
{
  return lua_cpcall(L, func, ud);
}

PBCOMMAND(int) PB_lua_load(lua_State *L, lua_Chunkreader reader, 
                          void *dt, const char *chunkname)
{
  return lua_load(L, reader, dt, chunkname);
}

PBCOMMAND(int) PB_lua_dump(lua_State *L, lua_Chunkwriter writer, void *data)
{
  return lua_dump(L, writer, data);
}

/*
** coroutine functions
*/
PBCOMMAND(int) PB_lua_yield(lua_State *L, int nresults)
{
  return lua_yield(L, nresults);
}

PBCOMMAND(int) PB_lua_resume(lua_State *L, int narg)
{
  return lua_resume(L, narg);
}

/*
** garbage-collection functions
*/
PBCOMMAND(int) PB_lua_getgcthreshold(lua_State *L)
{
  return lua_getgcthreshold(L);
}

PBCOMMAND(int) PB_lua_getgccount(lua_State *L)
{
  return lua_getgccount(L);
}

PBCOMMAND(void) PB_lua_setgcthreshold(lua_State *L, int newthreshold)
{
  lua_setgcthreshold(L, newthreshold);
}

/*
** miscellaneous functions
*/

PBCOMMAND(const char*) PB_lua_version()
{
  return lua_version();
}

PBCOMMAND(int) PB_lua_error(lua_State *L)
{
  return lua_error(L);
}

PBCOMMAND(int) PB_lua_next(lua_State *L, int idx)
{
  return lua_next(L, idx);
}

PBCOMMAND(void) PB_lua_concat(lua_State *L, int n)
{
  lua_concat(L, n);
}


/*
** Debug API
*/
PBCOMMAND(int) PB_lua_getstack(lua_State *L, int level, lua_Debug *ar)
{
  return lua_getstack(L, level, ar);
}

PBCOMMAND(int) PB_lua_getinfo(lua_State *L, const char *what, lua_Debug *ar)
{
  return lua_getinfo(L, what, ar);
}

PBCOMMAND(const char*) PB_lua_getlocal(lua_State *L, const lua_Debug *ar, int n)
{
  return lua_getlocal(L, ar, n);
}

PBCOMMAND(const char*) PB_lua_setlocal(lua_State *L, const lua_Debug *ar, int n)
{
  return lua_setlocal(L, ar, n);
}

PBCOMMAND(const char*) PB_lua_getupvalue(lua_State *L, int funcindex, int n)
{
  return lua_getupvalue(L, funcindex, n);
}

PBCOMMAND(const char*) PB_lua_setupvalue(lua_State *L, int funcindex, int n)
{
  return lua_setupvalue(L, funcindex, n);
}

PBCOMMAND(int) PB_lua_sethook(lua_State *L, lua_Hook func, int mask, int count)
{
  return lua_sethook(L, func, mask, count);
}

PBCOMMAND(lua_Hook) PB_lua_gethook(lua_State *L)
{
  return lua_gethook(L);
}

PBCOMMAND(int) PB_lua_gethookmask(lua_State *L)
{
  return lua_gethookmask(L);
}

PBCOMMAND(int) PB_lua_gethookcount(lua_State *L)
{
  return lua_gethookcount(L);
}

/*
** compatibility macros and functions
*/
PBCOMMAND(int) PB_lua_pushupvalues(lua_State *L)
{
  return lua_pushupvalues(L);
}

/* LUALIB.H */

/*
** Lua standard libraries
*/
PBCOMMAND(int) PB_lua_baselibopen(lua_State *L)
{
  return lua_baselibopen(L);
}

PBCOMMAND(int) PB_lua_tablibopen(lua_State *L)
{
  return lua_tablibopen(L);
}

PBCOMMAND(int) PB_lua_iolibopen(lua_State *L)
{
  return lua_iolibopen(L);
}

PBCOMMAND(int) PB_lua_strlibopen(lua_State *L)
{
  return lua_strlibopen(L);
}

PBCOMMAND(int) PB_lua_mathlibopen(lua_State *L)
{
  return lua_mathlibopen(L);
}

PBCOMMAND(int) PB_lua_dblibopen(lua_State *L)
{
  return lua_dblibopen(L);
}

PBCOMMAND(int) PB_lua_loadlibopen(lua_State *L)
{
  return lua_loadlibopen(L);
}

/* LAUXLIB.H */

/*
** compatibility macros and functions 
*/

PBCOMMAND(int) PB_lua_dofile(lua_State *L, char *filename)
{
  return lua_dofile(L, filename);
}

PBCOMMAND(int) PB_lua_dostring(lua_State *L, char *str)
{
  return lua_dostring(L, str);
}

PBCOMMAND(int) PB_lua_dobuffer(lua_State *L, const char *buff, 
                              size_t sz, const char *n)
{
  return lua_dobuffer(L, buff, sz, n);
}


