Global width, height
Global red, green, blue

Procedure lua_getglobal(L, s$)
  lua_pushstring(L, s$)
  lua_gettable(L, #LUA_GLOBALSINDEX)
EndProcedure

Procedure lua_istable(L, n) 
  If (lua_type(L,n) = #LUA_TTABLE)
    ProcedureReturn 1
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure lua_getfield(L, key$)
  lua_pushstring(L, key$)
  lua_gettable(L, -2); get background[key]
  If (lua_isnumber(L, -1) = 0)
    MessageRequester("Error", "Invalid component in background color!");
    End
  EndIf
  result = lua_tonumber(L, -1)
  lua_settop(L, -2) ; = lua_pop(L,n) = lua_settop(L, -(n)-1)
  ProcedureReturn result
EndProcedure


Procedure LoadConfig(FileName$)
  L = lua_open()
  lua_baselibopen(L)
  lua_iolibopen(L)
  lua_strlibopen(L)
  lua_mathlibopen(L)

  If (lua_dofile(L, FileName$) <> 0)
    MessageRequester("Error","Cannot run configuration file!")
    End
  Else
    lua_getglobal(L, "width")
    lua_getglobal(L, "height")

    If (lua_isnumber(L, lua_gettop(L)) = 0) Or (lua_isnumber(L, lua_gettop(L)-1) = 0)
      MessageRequester("Error","Invalid configuration file!")
      End
    Else 
      width   = lua_tonumber(L, lua_gettop(L))
      height  = lua_tonumber(L, lua_gettop(L)-1)
    EndIf
  
    lua_getglobal(L, "background")
    If (lua_istable(L, -1) = 0)
      MessageRequester("Error","'background' is not a valid color table")
      End
    Else 
      red   = lua_getfield(L, "r")
      green = lua_getfield(L, "g")
      blue  = lua_getfield(L, "b")
    EndIf

    lua_close(L)
  EndIf
EndProcedure

LoadConfig("config_complex.lua")

hWnd = OpenWindow(0, 100, 200, width, height, #PB_Window_SystemMenu , "Lua config_complex Example") 

  hBrush = CreateSolidBrush_(RGB(red, green, blue)) 
  SetClassLong_(hWnd, #GCL_HBRBACKGROUND, hBrush) 

  InvalidateRect_(hWnd, #NULL, #TRUE) 

  Repeat 
    EventID.l = WaitWindowEvent() 

    If EventID = #PB_Event_CloseWindow 
      Quit = 1 
    EndIf 

  Until Quit = 1 
  DeleteObject_(hBrush)
End
; ExecutableFormat=Windows
; CursorPosition=16
; FirstLine=21
; Executable=C:\Dokumente und Einstellungen\FloHimself\Desktop\background\config_complex.exe
; EOF